<template>
  <div>
    <PostComponent
      v-for="post of posts"
      :key="posts.indexOf(post)"
      :post="post"
    />
  <div class="bottom-spacing"></div>
  </div>
</template>

<script>
import utils from "../../../utils"
import CommonFunctions from "../../utils/CommonFunctions.js"
import {fetchRuneViewData} from "../../../utils/commonFunctions"

export default {
  data(){
    return {
      posts: []
    }
  },
  async asyncData({app, $services, $links, $axios}){
    console.log("AsyncData called")
    var i18n = app.i18n

    var {
      circulatingSupplyTxt,
      runeLocked,
      MCCN
    } = await fetchRuneViewData($services).catch(e => console.error(e));

    var markets = await $services.getAllMarkets().catch(e => console.error(e));

    var pools = undefined;
    if (MCCN && MCCN.pools) {
      pools = MCCN.pools;
    } else {
      let res = await $axios.get('https://midgard.thorchain.info/v2/' + 'pools')
      pools = res.data;
    }

    return {
          posts: [
            {
              thread: true,
              header: {
                avatar: require("~/assets/images/rune-view/avatar-light-rune.svg"),
              },
              layers: [
                {
                  type: "image",
                  image: require("~/assets/images/rune-view/rune-card.svg"),
                },
                {type: 'table-links', links: [
                  {text: i18n.t("RUNE Token")},
                  {text: i18n.t("RUNE Token Overview"), link: $links('rune_thorchain_docs_rune_overview')},
                ]},
                {type:'text', text: [
                  i18n.t('RUNE is the asset which powers the THORChain ecosystem and provides the economic incentives required to secure the network economically.')
                ]},
                {type: 'table-links', links: [
                  {text: i18n.t("Docs ↴")},
                  {text: i18n.t("Liquidity"), link: $links('rune_thorchain_docs_rune_liquidity')},
                  {text: i18n.t("Security"), link: $links('rune_thorchain_docs_rune_security')},
                  {text: i18n.t("Governance"), link: $links('rune_thorchain_docs_rune_governance')},
                  {text: i18n.t("Incentives"), link: $links('rune_thorchain_docs_rune_incentives')},
                  {text: i18n.t("Emissions"), link: $links('rune_thorchain_docs_emissions')},
                  {text: i18n.t("Schedule"), link: $links('rune_google_docs_emission_schedule')},
                ]},
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("RUNE Aiming for Deterministic Value"),
                avatar: require("~/assets/images/rune-view/avatar-arrow-up.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('If over 80% of circulating RUNE gets locked into THORChain liquidity pools, by economic design RUNE\'s market cap should be a minimum 3X the value of all non-RUNE assets locked into THORChain liquidity pools.')
                ]},
                {type:'text', text: [
                  i18n.t('THORChain currently supports the following non-RUNE assets: BTC, ETH, BNB, BCH, LTC.')
                ]},
                {
                  type: "image",
                  image: require("~/assets/images/thornames-view/supported-card.svg"),
                },
                {type:'text', text: [
                  i18n.t('The more RUNE hodlers provide liquidity with their RUNE, the more accurate deterministic RUNE becomes. Assuming 80% of circulating RUNE is locked into THORChain, you can simulate various outcomes for RUNE\'s price based on the future Total Value Locked (TVL) in THORChain and asset prices on that day.')
                ]},
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("What Influences TVL?"),
                avatar: require("~/assets/images/home-page/avatar-cursor.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('THORChain interfaces are used by Liquidity Providers to deposit their assets into liquidity pools in order to earn yield.')
                ]},
                {type:'text', text: [
                  i18n.t('The better these interfaces do at user experience, user interface designs, marketing etc, the higher their chances of attracting deposits into THORChain.')
                ]},
                {type:'text', text: [
                  i18n.t('It\'s important for the THORChain community to support interfaces in order to help grow the TVL in the network.')
                ]},
                {type: 'table-links', links: [
                  {text: i18n.t("Interfaces"), link: $links('slash_interfaces')},
                  {text: i18n.t("Liquidity Providers"), link: $links('slash_liquidity_providers')}
                ]},
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("Simulate RUNE Deterministic Value"),
                avatar: require("~/assets/images/insurance-view/avatar-calculator.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('RUNE’s value can be simulated by predicting market outcomes and the total value locked in the network.')
                ]},
                {type:'custom-component', component: {
                  name: 'simulator',
                  data: {
                    pools: pools,
                    markets: markets,
                    availablePools: [
                      { value: 'binancecoin', text: 'BNB', thorPool: 'BNB.BNB' },
                      { value: 'ethereum', text: 'ETH', thorPool: 'ETH.ETH' },
                      { value: 'dogecoin', text: 'DOGE', thorPool: 'DOGE.DOGE' },
                      { value: 'litecoin', text: 'LTC', thorPool: 'LTC.LTC' },
                      { value: 'bitcoin-cash', text: 'BCH', thorPool: 'BCH.BCH' },
                      { value: 'bitcoin', text: 'BTC', thorPool: 'BTC.BTC' },
                      { value: 'binance-usd', text: 'BUSD', thorPool: 'BNB.BUSD-BD1' },
                      { value: 'usd-coin', text: 'USDC', thorPool: 'ETH.USDC-0XA0B86991C6218B36C1D19D4A2E9EB0CE3606EB48' },
                      { value: 'tether', text: 'USDT', thorPool: 'ETH.USDT-0XDAC17F958D2EE523A2206206994597C13D831EC7' },
                      { value: 'avalanche-2', text: 'AVAX', thorPool: 'AVAX.AVAX' },
                      { value: 'cosmos', text: 'ATOM', thorPool: 'GAIA.ATOM' },
                    ],
                  }
                }}
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("What's THORChain's non-RUNE TVL?"),
                avatar: require("~/assets/images/insurance-view/avatar-question.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('THORChain is still in ChaosNet. At MainNet caps will be removed allowing an unlimited amount of value to enter the network.')
                ]},
                {type: 'table', table:{
                  rows: [
                    {cols: [i18n.t("runePage.deterministicRuneButSir.links[0][0]"), {
                      content: ["$"+MCCN.nonRuneTVLTxt + " USD"],
                       style: 'text-align: right'}]},
                    {cols: [
                    {content: i18n.t("RUNE Circulating Supply"), style: 'width: 200%'},
                    {content: circulatingSupplyTxt, style: 'text-align: right; width: 50%'}]},
                  ]}
                },
                {type: 'table-links', links: [
                  {text: i18n.t("Network Explorers"), link: $links('slash_network_explorers')},
                ]},
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("Where is RUNE Issued?"),
                avatar: require("~/assets/images/developers-view/avatar-block.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('During its original distribution phase, RUNE was issued on BNB chain. That\'s why today you\'ll see the most most liquidity for RUNE on exchanges as BNB.RUNE. Later ETH.RUNE was issued in order to provision liquidity via the Ethereum network.')
                ]},
                {type:'text', text: [
                  i18n.t('As THORChain rolled out multi-chain, native RUNE known as THOR.RUNE became available. Native THOR.RUNE is issued on its own chain, and is exclusively available via THORChain interfaces. If you buy BNB.RUNE off an exchange, or ETH.RUNE via a DEX, you can convert your BNB.RUNE or ETH.RUNE to native THOR.RUNE via THORChain interfaces.')
                ]},
                {type:'text', text: [
                  i18n.t('Your balance address tells you which RUNE you have:')
                ]},
                {type: 'table', table:{
                  style: "text-align: center",
                  rows: [
                   {
                      cols: [
                        {content: "Issued Chain", style: 'text-align: left'},
                        {content: "Address Starts With", style: ''}
                      ]
                    },
                    {
                      cols: [
                        {content: "BNB", style: 'text-align: left'},
                        {content: "bnb...", style: ''}
                      ]
                    },
                    {
                      cols: [
                        {content: "ETH", style: 'text-align: left'},
                        {content: "0x...", style: ''}
                      ]
                    },
                    {
                      cols: [
                        {content: "THOR", style: 'text-align: left'},
                        {content: "thor...", style: ''}
                      ]
                    }
                  ]}
                }
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("Upgrading to THOR.RUNE"),
                avatar: require("~/assets/images/rune-view/avatar-light-rune.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('If you want to participate in THORChain liquididty pools, you must enter positions with the native THOR.RUNE. Some interfaces allow you to enter liquidity pooling positions assymetrically, this means that you deposit only your BTC, ETH, BNB, LTC or BCH. In that case, the network automatically sells 50% of your asset for THOR.RUNE. On withdrawal, the interface will also sell your THOR.RUNE back into your original asset.')
                ]},
                {type:'text', text: [
                  i18n.t('You can upgrade your BNB.RUNE or ETH.RUNE to THOR.RUNE via a variety of THORChain ecosystem interfaces.')
                ]},
                {type: 'table-links', links: [
                  {text: i18n.t("Upgrade to THOR.RUNE ↴")},
                  {text: i18n.t("Interfaces"), link: $links('slash_interfaces')},
                ]},
              ]
            },
            {
              thread: true,
              id: '#tradeRune',
              header: {
                text: i18n.t("Where Can I Trade RUNE?"),
                avatar: require("~/assets/images/rune-view/avatar-trade.svg"),
              },
              layers: [
                {type:'text', text: [i18n.t('If you want to trade native THOR.RUNE, you\'ll have to use one of the ecosystem interfaces.')]},
                {type: 'table-links', links: [
                  {text: i18n.t("THOR.RUNE ↴")},
                  {text: i18n.t("THORSwap"), link: $links('slash_interfaces_links_thorswap')},
                  {text: i18n.t("ASGARDEX Desktop"), link: $links('slash_interfaces_links_asgardex')},
                  {text: i18n.t("SKIP Exchange"), link: $links('slash_interfaces_links_skip')},
                  {text: i18n.t("Brokkr"), link: $links('slash_interfaces_links_brokkr')},
                  {text: i18n.t("Interfaces"), link: $links('slash_interfaces')},
                ]},
                {type:'text', text: [i18n.t('If you want to trade native BNB.RUNE or ETH.RUNE, you can use the various markets listed below.')]},
                {type: 'table-links', links: [
                  {text: i18n.t("BNB.RUNE or ETH.RUNE ↴")},
                ]},
                {type: 'table', table: {
                  rows: await CommonFunctions.getCoingeckoTable($services, $links)
                }}
              ]
            },
            {
              thread: true,
              header: {
                text: i18n.t("Where Can I Store RUNE?"),
                avatar: require("~/assets/images/home-page/avatar-cursor.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('We recommend XDEFI Wallet. It supports mutliple chains and most THORChain interfaces support the hot wallet. Although if you plan to swap/pool on mobile, you\'re better off exploring the various THORChain interfaces instead as XDEFI doesn\'t support mobile yet.')
                ]},
                {
                  type: "image",
                  image: require("~/assets/images/interfaces-view/xdefi-card.svg"),
                },
                {type: 'table-links', links: [
                  {text: i18n.t("XDEFI Wallet"), link: $links('slash_wallets_xdefi')},
                  {text: i18n.t("Wallets"), link: $links('slash_wallets')},
                  {text: i18n.t("Interfaces"), link: $links('slash_interfaces')},
                ]},
              ]
            },
            {
              thread: false,
              header: {
                text: i18n.t("Can I Contribute to Development?"),
                avatar: require("~/assets/images/arbitrageurs-view/avatar-dev.svg"),
              },
              layers: [
                {type:'text', text: [
                  i18n.t('THORChain is open-source. Any developer interested in developing the protocol, ecosystem or supporting a new chain client can join the community.')
                ]},
                {type: 'table-links', links: [
                  {text: i18n.t("Developers"), link: $links('slash_developers')},
                ]},
              ]
            },
          ]
    }
  }
}
</script>
<style>
.bottom-spacing{
  height: 5rem;
}
</style>
